#!/usr/bin/perl -w
# script to query the Varnish manager process and collect statistics
# for Cacti. Based on the python script by dmuntean.
#

use strict;
use Net::Telnet ();

my $host=shift || 'localhost';		# default host
my $port=shift || 6082;			# default port number

my $t=new Net::Telnet( Timeout => 10,
			Host=>$host,
			Port=>$port,
			Prompt=>'//'
		);
$t->open() || die "Can't open connection!" ;
$t->put(String=>"stats\n");
my ($l,$d)=$t->waitfor('/N duplicate purges removed/');


my @values=split /\n/,$l;
my $count=1;

foreach my $x (@values) {

	# a little bit of processing is required, the value/id
	# are reversed, spaces in the ids names are removed and
	# uppercases are converted in lowercase
	
	my $val=$x;
	my $id=$x;
	$val=~s/^ +([0-9]+) .*$/$1/;
	$val=~s/ //g;
	$id=~s/^ +[0-9]+ +(.*)$/$1/;
	$id=~s/^ +//g;
	$id=~s/ +$//g;
	$id=~s/ /_/g;
	$id=lc $id;

	if( $count > 1 && $id ne '' ) {

		# the bytes_allocated and bytes_free are, unfortunately,
		# not unique, so I replace them with 'cache_allocated'
		# and 'cache_free'.
		if( $id =~ /^bytes_allocated$/ ) {
			$id='cache_allocated';
		}
		if( $id =~ /^bytes_free$/ ) {
			$id='cache_free';
		}
		print $id.":".$val." ";
	}
	$count++;
}

print "\n";

# close the connection
$t->put("quit");
$t->close();
